#include <stdint.h>
#include <stm32f10x.h>

#define BUFSIZE 32
typedef struct {
    uint8_t buf[BUFSIZE];
    uint8_t head;
    uint8_t tail;
    uint8_t cnt;
} Q_t;

Q_t txqueue;
Q_t rxqueue;

int q_get(Q_t *q)
{
    int c;
    if (q->cnt > 0) {
	q->cnt -= 1;
	c = q->buf[q->tail++];
	q->tail &= (BUFSIZE-1);
	return c;
    }
    return -1;
}

void q_put(Q_t *q, int c)
{
    if (q->cnt < BUFSIZE) {
	q->cnt += 1;
	q->buf[q->head++] = c;
	q->head &= (BUFSIZE-1);
    }
}
